/* linux/include/asm-arm/arch-at91sam9260/at91sam9260_ebi.h
 * 
 * Hardware definition for the ebi peripheral in the ATMEL at91sam9260 processor
 * 
 * Generated  12/07/2006 (15:04:00) AT91 SW Application Group from EBI_SAM9260 V1.1
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT ARE
 * DISCLAIMED. IN NO EVENT SHALL ATMEL BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
 * OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * You should have received a copy of the  GNU General Public License along
 * with this program; if not, write  to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#ifndef __AT91SAM9260_EBI_H
#define __AT91SAM9260_EBI_H

/* -------------------------------------------------------- */
/* EBI ID definitions for  AT91SAM9260           */
/* -------------------------------------------------------- */

/* -------------------------------------------------------- */
/* EBI Base Address definitions for  AT91SAM9260   */
/* -------------------------------------------------------- */
#define AT91C_BASE_EBI       	0xFFFFEA00 /**< EBI base address */

/* -------------------------------------------------------- */
/* PIO definition for EBI hardware peripheral */
/* -------------------------------------------------------- */
#define AT91C_PC4_A23      	(1 << 4) /**< Address Bus[23] */
#define AT91C_PC5_A24      	(1 << 5) /**< Address Bus[24] */
#define AT91C_PC10_A25_CFRNW 	(1 << 10) /**< Address Bus[25] */
#define AT91C_PC16_D16      	(1 << 16) /**< Data Bus[16] */
#define AT91C_PC17_D17      	(1 << 17) /**< Data Bus[17] */
#define AT91C_PC18_D18      	(1 << 18) /**< Data Bus[18] */
#define AT91C_PC19_D19      	(1 << 19) /**< Data Bus[19] */
#define AT91C_PC20_D20      	(1 << 20) /**< Data Bus[20] */
#define AT91C_PC21_D21      	(1 << 21) /**< Data Bus[21] */
#define AT91C_PC22_D22      	(1 << 22) /**< Data Bus[22] */
#define AT91C_PC23_D23      	(1 << 23) /**< Data Bus[23] */
#define AT91C_PC24_D24      	(1 << 24) /**< Data Bus[24] */
#define AT91C_PC25_D25      	(1 << 25) /**< Data Bus[25] */
#define AT91C_PC26_D26      	(1 << 26) /**< Data Bus[26] */
#define AT91C_PC27_D27      	(1 << 27) /**< Data Bus[27] */
#define AT91C_PC28_D28      	(1 << 28) /**< Data Bus[28] */
#define AT91C_PC29_D29      	(1 << 29) /**< Data Bus[29] */
#define AT91C_PC30_D30      	(1 << 30) /**< Data Bus[30] */
#define AT91C_PC31_D31      	(1 << 31) /**< Data Bus[31] */
#define AT91C_PC15_NWAIT    	(1 << 15) /**< External Wait Signal */


/* -------------------------------------------------------- */
/* Register offset definition for EBI hardware peripheral */
/* -------------------------------------------------------- */
#define EBI_DUMMY 	(0x0000) 	/**< Dummy register - Do not use */

/* -------------------------------------------------------- */
/* Bitfields definition for EBI hardware peripheral */
/* -------------------------------------------------------- */

#endif /* __AT91SAM9260_EBI_H */
