/* linux/include/asm-arm/arch-at91sam9260/at91sam9260_uhp.h
 * 
 * Hardware definition for the uhp peripheral in the ATMEL at91sam9260 processor
 * 
 * Generated  12/07/2006 (15:04:00) AT91 SW Application Group from UHP_6127A V1.1
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT ARE
 * DISCLAIMED. IN NO EVENT SHALL ATMEL BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
 * OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * You should have received a copy of the  GNU General Public License along
 * with this program; if not, write  to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#ifndef __AT91SAM9260_UHP_H
#define __AT91SAM9260_UHP_H

/* -------------------------------------------------------- */
/* UHP ID definitions for  AT91SAM9260           */
/* -------------------------------------------------------- */
#ifndef AT91C_ID_UHP
#define AT91C_ID_UHP   	20 /**< USB Host Port id */
#endif /* AT91C_ID_UHP */

/* -------------------------------------------------------- */
/* UHP Base Address definitions for  AT91SAM9260   */
/* -------------------------------------------------------- */
#define AT91C_BASE_UHP       	0x00500000 /**< UHP base address */

/* -------------------------------------------------------- */
/* PIO definition for UHP hardware peripheral */
/* -------------------------------------------------------- */

/* -------------------------------------------------------- */
/* Register offset definition for UHP hardware peripheral */
/* -------------------------------------------------------- */
#define UHP_HcRevision 	(0x0000) 	/**< Revision */
#define UHP_HcControl 	(0x0004) 	/**< Operating modes for the Host Controller */
#define UHP_HcCommandStatus 	(0x0008) 	/**< Command & status Register */
#define UHP_HcInterruptStatus 	(0x000C) 	/**< Interrupt Status Register */
#define UHP_HcInterruptEnable 	(0x0010) 	/**< Interrupt Enable Register */
#define UHP_HcInterruptDisable 	(0x0014) 	/**< Interrupt Disable Register */
#define UHP_HcHCCA 	(0x0018) 	/**< Pointer to the Host Controller Communication Area */
#define UHP_HcPeriodCurrentED 	(0x001C) 	/**< Current Isochronous or Interrupt Endpoint Descriptor */
#define UHP_HcControlHeadED 	(0x0020) 	/**< First Endpoint Descriptor of the Control list */
#define UHP_HcControlCurrentED 	(0x0024) 	/**< Endpoint Control and Status Register */
#define UHP_HcBulkHeadED 	(0x0028) 	/**< First endpoint register of the Bulk list */
#define UHP_HcBulkCurrentED 	(0x002C) 	/**< Current endpoint of the Bulk list */
#define UHP_HcBulkDoneHead 	(0x0030) 	/**< Last completed transfer descriptor */
#define UHP_HcFmInterval 	(0x0034) 	/**< Bit time between 2 consecutive SOFs */
#define UHP_HcFmRemaining 	(0x0038) 	/**< Bit time remaining in the current Frame */
#define UHP_HcFmNumber 	(0x003C) 	/**< Frame number */
#define UHP_HcPeriodicStart 	(0x0040) 	/**< Periodic Start */
#define UHP_HcLSThreshold 	(0x0044) 	/**< LS Threshold */
#define UHP_HcRhDescriptorA 	(0x0048) 	/**< Root Hub characteristics A */
#define UHP_HcRhDescriptorB 	(0x004C) 	/**< Root Hub characteristics B */
#define UHP_HcRhStatus 	(0x0050) 	/**< Root Hub Status register */
#define UHP_HcRhPortStatus 	(0x0054) 	/**< Root Hub Port Status Register */

/* -------------------------------------------------------- */
/* Bitfields definition for UHP hardware peripheral */
/* -------------------------------------------------------- */

#endif /* __AT91SAM9260_UHP_H */
